<template>
    <ob-form :form-data="formData" :form-model="formModel" @submit="onSubmitHandler">
        <div class="row">
            <div class="col-xs-6">
                <ob-input
                        :label="dictionaryRu.modal.resource_species"
                        :disabled="true"
                        v-model="dataSource.name"
                        property="resource_species.name"
                />
            </div>
            <div class="col-xs-6">
                <ob-input
                        :label="dictionaryRu.modal.resource_sub_type"
                        :disabled="true"
                        v-model="dataSource.title"
                        property="resource_sub_type.name"
                />
            </div>
        </div>
        <div class="row">
            <div class="col-xs-12">
                <ob-select
                        :label="dictionaryRu.modal.resource_mask"
                        :items="masks"
                        :disabled="disabledForm"
                        v-model="dataSource.resource_mask_uuid"
                        property="resource_mask_uuid"
                        :placeholder="dictionaryRu.modal.resource_mask_placeholder"
                        display-exp="mask"
                        value-exp="uuid"
                />
            </div>
        </div>
        <div class="row">
            <div class="col-xs-12">
                <template v-if="dataSource.resource_mask_uuid">
                    <ob-select
                            :label="dictionaryRu.modal.resource_pattern"
                            :is-multiselect="true"
                            :is-tagbox="true"
                            :is-dropdown="true"
                            :items="patterns"
                            v-model="formData.resourcePatternUuids"
                            property="resourcePatternUuids"
                            :placeholder="dictionaryRu.modal.resource_pattern_placeholder"
                            display-exp="title"
                            value-exp="uuid"
                            :is-standart="true"
                    />
                </template>
            </div>
        </div>
    </ob-form>
</template>

<script>
    import FormValidationMixin from 'common-components/src/obComponents/obForm/FormValidationMixin'
    import ObForm from "common-components/src/obComponents/obForm";
    import models from '@/models';
    import api from '@/api'
    import cloneDeep from 'clone-deep';
    import ObInput from "common-components/src/obComponents/obInput";
    import ObSelect from "common-components/src/obComponents/obSelect";
    import { dictionaryDefault } from '@/translations/ru/default';
    import { dictionary} from '@/translations/ru/dictionaries__resources__resource_types';

    export default {
        name: "ResourceType",
        components: {ObSelect, ObInput, ObForm },
        mixins: [
            FormValidationMixin
        ],
        props: {
            masks: {
                type: Array,
                required: true,
                default: () => []
            },
            disabledForm: {
                type: Boolean,
                default: true
            }
        },
        watch: {
            'dataSource.resource_mask_uuid' (newVal, oldVal) {
                if(this.dataSource.resource_mask_uuid && this.dataSource.resource_mask_uuid.length > 0) {
                    this.loadMasks();
                }
                if (newVal !== oldVal) {
                    this.formData.resourcePatternUuids = [];
                }
            }
        },
        computed: {
            formModel () {
                return models.resourceType.add;
            },
            isNew () {
                return this.dataSource.status;
            }
        },
        data () {
            return {
                patterns: [],
                dictionaryRu: Object.assign(dictionary, dictionaryDefault)
            }
        },
        async mounted() {
            if (!this.isNew) {
                await this.loadMasks();
            }
        },
        methods: {
            getPatterns(mask, resourcePattern) {
                let _mask =  mask;
                _mask = resourcePattern.parameters['X.X'] ? _mask.replaceAll('X.X', ' ' + resourcePattern.parameters['X.X'] + ' ' ) : _mask;
                _mask = resourcePattern.parameters.XXX ? _mask.replaceAll('XXX', ' ' + resourcePattern.parameters.XXX + ' ' ) : _mask;
                _mask = resourcePattern.parameters.YYY ? _mask.replaceAll('YYY', ' ' + resourcePattern.parameters.YYY + ' ' ) : _mask;
                _mask = resourcePattern.parameters.ZZZ ? _mask.replaceAll('ZZZ', ' ' + resourcePattern.parameters.ZZZ + ' ' ) : _mask;
                _mask = resourcePattern.parameters.XX ? _mask.replaceAll('XX', ' ' + resourcePattern.parameters.XX + ' ' ) : _mask;
                _mask = resourcePattern.parameters.YY ? _mask.replaceAll('YY', ' ' + resourcePattern.parameters.YY + ' ' ) : _mask;
                _mask = resourcePattern.parameters.ZZ ? _mask.replaceAll('ZZ', ' ' + resourcePattern.parameters.ZZ + ' ' ) : _mask;
                _mask = resourcePattern.parameters.X ? _mask.replaceAll('X', ' ' + resourcePattern.parameters.X + ' ' ) : _mask;
                _mask = resourcePattern.parameters.Y ? _mask.replaceAll('Y', ' ' + resourcePattern.parameters.Y + ' ' ) : _mask;
                _mask = resourcePattern.parameters.Z ? _mask.replaceAll('Z', ' ' + resourcePattern.parameters.Z + ' ' ) : _mask;
                _mask = resourcePattern.parameters.A ? _mask.replaceAll('A', ' ' + resourcePattern.parameters.A + ' ' ) : _mask;
                _mask = resourcePattern.parameters.B ? _mask.replaceAll('B', ' ' + resourcePattern.parameters.B + ' ' ) : _mask;
                _mask = _mask.replaceAll(' ', ' /').substring(2);
                return _mask;
            },
            loadMasks() {
                api.resources.getPatternsByMask(this.dataSource.resource_mask_uuid).then(({ data }) => {
                        this.patterns = data.resourcePatterns.map(pattern => {
                            let mask = this.masks.find(m => m.uuid === pattern.maskUuid);
                            pattern.title = this.getPatterns(mask.mask, pattern);
                            pattern.mask_uuid = mask.uuid;
                            return pattern;
                        });
                }).catch((e) => {
                    console.error(e);
                    this.$notification({type: 'system_notification_error', message: 'Ошибка загрузки данных'})
                })
            },
            async onSubmitHandler() {
                let data = cloneDeep(this.formData);
                let notificationId = new Date().getTime()+'save';
                try {
                    this.$notification({type: 'system_notification_in_load', message: 'Сохранение', id: notificationId});
                    await api.resources.createResourceTypes(data);
                    this.$emit('save');
                    this.$refs.rolesModal.close()
                    this.onCloseForm()
                    this.$notification({
                        type: 'system_notification_success',
                        message: 'Сохранено'
                    })
                } catch (e) {
                    console.error(e);
                    this.$notification({
                        type: 'system_notification_error',
                        message: 'Не сохранено'
                    })
                } finally {
                    this.$notification({event: 'close', id: notificationId})
                }
            },
        }
    }
</script>